Sub Main()

    ' Start custom variables
    htmlFile$ = "index.html"
    ' End custom variables

    ' Constants
    POOL_EVENT_FILE_DOWNLOADED = 1
    POOL_EVENT_FILE_FAILED = -1
    POOL_EVENT_ALL_DOWNLOADED = 2
    POOL_EVENT_ALL_FAILED = -2

    regHtmlSec = CreateObject("roRegistrySection", "html")
    regHtmlSec.Write("disable-web-security", "1")
    regHtmlSec.Flush()


    pemFile = CreateObject("roReadFile","cert.pem")

    if type(pemFile) = "roReadFile" then
        m.SystemLog = CreateObject("roSystemLog")
        m.k = CreateObject("roKeystore")       
	    ok = m.k.AddCACertificate("SD:/cert.pem")
        
        if ok then
            m.SystemLog.SendLine(" @@@ Self-Signed Cert SUCCESFULLY added to roKeyStore @@@ ")
        else
            Failure_Reason$ = m.k.GetFailureReason()
            m.SystemLog.SendLine(" @@@ Failed to Add Cert to roKeyStore @@@ " + Failure_Reason$)
        end if	
    end if

      ' Message port
    m.msgPort = CreateObject("roMessagePort")

    m.SetupFunctionHandlers = SetupFunctionHandlers
	SetupFunctionHandlers()
    m.AddHttpHandlers()
        
    ' Start and show signagelive straight away
    url$ = "file:///" + htmlFile$
    m.htmlWidget = CreateHtmlWidget(url$)
    m.htmlWidget.Show() 
    m.htmlWidgetShown = true
    m.webPages = CreateObject("roAssociativeArray")
    
    vm=CreateObject("roVideoMode")
    width=vm.GetResX()
    height=vm.GetResY()

    'Setup Keyboard
    m.keyboard = CreateObject("roKeyboard")
    m.keyboard.SetPort(m.msgPort)

    'Setup touch screen
    m.touchscreen = CreateObject("roTouchScreen")
    m.touchscreen.SetPort(m.msgPort)
    'm.touchscreen.SetResolution(width, height)
    m.touchscreen.AddRectangleRegion(0,0,width,height,2)    

    ' Always
    while true

        ' Get message
        event = wait(0, m.msgPort)

        if type(event) = "roTouchEvent" then
            
            m.htmlWidget.PostJSMessage({ type: "TouchEvent" })

        else if type(event) = "roKeyboardPress" then
            
            m.htmlWidget.PostJSMessage({ type: "KeyboardEvent" })

        else if type(event) = "roHtmlWidgetEvent" then
        
                payload = event.GetData()
                            
                if payload.reason = "message" then
                    
                    if payload.message.action <> invalid then
                    
                        if payload.message.action = "create_HTML_Widget" then
                                               
                            index% = int((val(payload.message.index)))
                            RecX% = int((val(payload.message.RecX)))
                            RecY% = int((val(payload.message.RecY)))
                            RecWidth% = int((val(payload.message.RecWidth)))
                            RecHeight% = int((val(payload.message.RecHeight)))
                            Rotate% = int((val(payload.message.Rotate)))
                            
                            
                            if m.HTMLWidgetList[index%] <> invalid then
                                m.HTMLWidgetList[index%] = invalid
                            end if

                            m.HTMLWidgetList[index%] = m.WebWindowHTML(index%, payload.message.url , RecX%, RecY%, RecWidth%, RecHeight%, Rotate%)
                        
                        else if payload.message.action = "delete_HTML_Widget" then
                        
                            'print "Action: "; payload.message.action
                            'print "Action: "; payload.message.index
                            
                            index% = int((val(payload.message.index)))
                            
                            if m.HTMLWidgetList[index%] <> invalid then
                                m.HTMLWidgetList[index%].Hide()
                                m.HTMLWidgetList[index%] = invalid				
                            end if
                        end if
                        
                    end if	
                    
                end if
        	 
        else
        
        func = event.GetUserData()
		If type(func) = "roAssociativeArray" and type(func.__invoke) = "roFunction" Then
		    func(event)
		Endif
        end if


    end while

End Sub


Function CreateHtmlWidget(url$ as String)

    vm=CreateObject("roVideoMode")
    width=vm.GetResX()
    height=vm.GetResY()
    rect=CreateObject("roRectangle", 0, 0, width, height)
	CreateDirectory("localStorage")
	CreateDirectory("webDatabase")
    CreateDirectory("appCache")

	is = {
		port: 2999
	}

    sysInfo = CreateObject("roDeviceInfo")

    if sysInfo.FirmwareIsAtLeast("7.0.33") then
	
        security = {
                websecurity: false,
                camera_enabled: true
        }
        
        config = {
            nodejs_enabled: true,
            inspector_server: is,
            brightsign_js_objects_enabled: true,
            javascript_enabled: true,
            mouse_enabled: true,
            port: m.msgPort,
            security_params: {
                websecurity: false,
                camera_enabled: true
            },
            hwz_default: "z-index:-1",
            url: url$,
            storage_path : "localStorage"
        }
        
        htmlWidget = CreateObject("roHtmlWidget", rect, config)        
    else
        config = {
            nodejs_enabled: true
            inspector_server: is
            brightsign_js_objects_enabled: true
            url: url$
        }
        
        htmlWidget = CreateObject("roHtmlWidget", rect, config)
        htmlWidget.EnableSecurity(false)
        htmlWidget.EnableJavascript(true)
        htmlWidget.StartInspectorServer(2999)
        jsClasses = CreateObject("roAssociativeArray")
        jsClasses["*"] = [ "*" ]
        htmlWidget.AllowJavaScriptUrls(jsClasses)
        htmlWidget.setLocalStorageDir("localStorage")
        htmlWidget.setLocalStorageQuota(1000000000)
        htmlWidget.SetWebDatabaseDir("webDatabase")
        htmlWidget.SetWebDatabaseQuota(1000000000)

    end if

    byteArray = CreateObject("roByteArray")
    byteArray.ReadFile("data/clientId.json")

    if byteArray.Count() > 0 then

        clientIdJson = byteArray.ToAsciiString()  
        clientIdObject = ParseJson(clientIdJson)
        htmlWidget.SetUserAgentSuffix("SLGUID/"+clientIdObject.clientId)
        
    end if
    
    return htmlWidget

End Function
'''''''''''''''''''''''''''


Sub SetupFunctionHandlers()
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	m.AddHttpHandlers = AddHttpHandlers
	m.GetNetworkInfo = GetNetworkInfo
    m.TurnScreenOff = TurnScreenOff
    m.TurnScreenOn = TurnScreenOn
    m.SetTimezone = SetTimezone
    m.GetTimezone = GetTimezone
	m.GetNicInfo = GetNicInfo
    m.GetStorageTotal = GetStorageTotal
    m.GetStorageUsed = GetStorageUsed
    m.GetStorageType = GetStorageType
    m.AudioMute = AudioMute
    m.AudioSetVolume = AudioSetVolume
    m.SetNetworkingSettings = SetNetworkingSettings
    m.SetVideoMode = SetVideoMode
    m.WebWindowHTML = WebWindowHTML
	m.SendHttpResponse = SendHttpResponse
	m.HTMLWidgetList = CreateObject("roArray", 10, true)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub EventLoop()
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	while true
		event = wait(0, m.msgPort)
		func = event.GetUserData()
		If type(func) = "roAssociativeArray" and type(func.__invoke) = "roFunction" Then
			func(event)
		Endif
	End while
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub AddHttpHandlers()
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	m.localServer = CreateObject("roHttpServer", { port: 8080 })
	m.localServer.SetPort(m.msgPort)
	getNetworkInfoAA = { __invoke: m.GetNetworkInfo, mVar: m }
    turnScreenOnAA = { __invoke: m.TurnScreenOn, mVar: m }
    turnScreenOffAA = { __invoke: m.TurnScreenOff, mVar: m }
    setTimezoneAA = { __invoke: m.SetTimezone, mVar: m }
    getTimezoneAA = { __invoke: m.GetTimezone, mVar: m }
    getStorageTotalAA = { __invoke: m.GetStorageTotal, mVar: m }
    getStorageUsedAA = { __invoke: m.GetStorageUsed, mVar: m }
    getStorageTypeAA = { __invoke: m.GetStorageType, mVar: m }
    audioMuteAA = { __invoke: m.AudioMute, mVar: m }
    audioSetVolumeAA = { __invoke: m.AudioSetVolume, mVar: m }
    setNetworkingSettingsAA = { __invoke: m.SetNetworkingSettings, mVar: m }
    setVideModeAA = { __invoke: m.SetVideoMode, mVar: m }

	m.localServer.AddGetFromEvent({ url_path: "/get-network-info", user_data: getNetworkInfoAA, passwords: invalid })
    m.localServer.AddGetFromEvent({ url_path: "/turn-screen-on", user_data: turnScreenOnAA, passwords: invalid })
    m.localServer.AddGetFromEvent({ url_path: "/turn-screen-off", user_data: turnScreenOffAA, passwords: invalid })
    m.localServer.AddPostToString({ url_path: "/set-timezone", user_data: setTimezoneAA, passwords: invalid })
    m.localServer.AddGetFromEvent({ url_path: "/get-timezone", user_data: getTimezoneAA, passwords: invalid })
    m.localServer.AddGetFromEvent({ url_path: "/get-storage-total", user_data: getStorageTotalAA, passwords: invalid })
    m.localServer.AddGetFromEvent({ url_path: "/get-storage-used", user_data: getStorageUsedAA, passwords: invalid })
    m.localServer.AddGetFromEvent({ url_path: "/get-storage-type", user_data: getStorageTypeAA, passwords: invalid })
    m.localServer.AddPostToString({ url_path: "/audio-mute", user_data: audioMuteAA, passwords: invalid })
    m.localServer.AddPostToString({ url_path: "/audio-set-volume", user_data: audioSetVolumeAA, passwords: invalid })
    m.localServer.AddPostToString({ url_path: "/set-network-settings", user_data: setNetworkingSettingsAA, passwords: invalid })
    m.localServer.AddPostToString({ url_path: "/set-video-mode", user_data: setVideModeAA, passwords: invalid })

    'AddPostToString
    'Use the roHttpEvent.GetRequestBodyString() method to retrieve the posted body.
End Sub


Sub SetNetworkingSettings(e as Object)

    networkSettings = ParseJson(e.GetRequestBodyString())
    networkConfig = {}

    networkResult = true

    if networkSettings.useWifi then   
        networkConfig = CreateObject("roNetworkConfiguration", 1)
        if networkConfig <> invalid then
            'Configure wifi
            networkConfig.ResetInterfaceSettings()
            networkResult = networkResult AND networkConfig.SetWiFiESSID(networkSettings.wifiSSID)
            networkResult = networkResult AND networkConfig.SetWiFiPassphrase(networkSettings.wifiPassphrase)
        else
            'dhcp wired
            networkConfig = CreateObject("roNetworkConfiguration", 0)
            networkConfig.ResetInterfaceSettings()
        end if
    else 
        'dhcp wired
        networkConfig = CreateObject("roNetworkConfiguration", 0)
        networkConfig.ResetInterfaceSettings()
    end if

    networkConfig.ResetHostSettings()

    if networkSettings.useDHCP then
         networkResult = networkResult AND networkConfig.SetDHCP()
    else
        ipResult = networkConfig.SetIP4Address(networkSettings.ipAddress)
        networkResult = networkResult AND ipResult

        netmaskResult = networkConfig.SetIP4Netmask(networkSettings.subnetMask)
        networkResult = networkResult AND netmaskResult

        gatewayResult = networkConfig.SetIP4Gateway(networkSettings.defaultGateway)
        networkResult = networkResult AND gatewayResult
          
        if networkSettings.dns1 <> "" then
            cleardnsresult = networkConfig.SetDNSServers([])
            networkResult = networkResult AND networkConfig.AddDNSServer(networkSettings.dns1)
        end if
            
        if networkSettings.dns2 <> "" then
            networkResult = networkResult AND networkConfig.AddDNSServer(networkSettings.dns2)
        end if
    end if

    

    if networkSettings.proxy <> "" AND networkSettings.proxy <> invalid then
        networkResult = networkResult AND networkConfig.SetProxy(networkSettings.proxy)
        networkResult = networkResult AND networkConfig.SetProxyBypass(["localhost"])
    end if 

    networkResult = networkResult AND networkConfig.SetTimeServer(networkSettings.timeServerUrl)
    networkResult = networkResult AND networkConfig.Apply()
    result = {}
    result.result = networkResult
    
    SendHttpResponse(e, result, 200)
End Sub

Sub AudioSetVolume(e as Object)

    audioVolumeRequest = ParseJson(e.GetRequestBodyString())
    hdmi = CreateObject("roAudioOutput","hdmi")
    spdif = CreateObject("roAudioOutput","spdif")
    analog = CreateObject("roAudioOutput","analog")

    if type(hdmi) = "roAudioOutput" then
        hdmi.SetMute(false)
        hdmi.SetVolume(audioVolumeRequest.volume)
    end if

    if type(spdif) = "roAudioOutput" then
        spdif.SetMute(false)
        spdif.SetVolume(audioVolumeRequest.volume)
    end if

    if type(analog) = "roAudioOutput" then
        analog.SetMute(false)
        analog.SetVolume(audioVolumeRequest.volume)
    end if

    result = {}
    result.result =  true
    
    SendHttpResponse(e, result, 200)
End Sub

Sub AudioMute(e as Object)

    audioVolumeRequest = ParseJson(e.GetRequestBodyString())
    hdmi = CreateObject("roAudioOutput","hdmi")
    spdif = CreateObject("roAudioOutput","spdif")
    analog = CreateObject("roAudioOutput","analog")

    if type(hdmi) = "roAudioOutput" then
        hdmi.SetMute(audioVolumeRequest.muted)
    end if

    if type(spdif) = "roAudioOutput" then
        spdif.SetMute(audioVolumeRequest.muted)
    end if

    if type(analog) = "roAudioOutput" then
        analog.SetMute(audioVolumeRequest.muted)
    end if

    result = {}
    result.result =  true
    
    SendHttpResponse(e, result, 200)

End Sub

Sub SetVideoMode(e as Object)

    result = {}
    result.result =  true
    
    requestObj = ParseJson(e.GetRequestBodyString())

    vMode = CreateObject("roVideoMode") 

    currentVideoMode = vMode.GetMode() 
    nextVideoMode = vMode.GetModeForNextBoot()

    if currentVideoMode <> requestObj.videoMode then
        vMode.SetMode(requestObj.videoMode)
    end If

    if nextVideoMode <> requestObj.videoMode then
        result.result = vMode.SetModeForNextBoot(requestObj.videoMode)

        if result.result <> true then
            vMode.SetModeForNextBoot("auto")
        end if
    end if

    SendHttpResponse(e, result, 200)

End Sub

Sub GetStorageUsed(e as Object)

    t = CreateObject("roStorageInfo","SD:")  

    result = {}
    result.result = t.GetUsedInMegabytes()
    
    SendHttpResponse(e, result ,200)
End Sub

Sub GetStorageType(e as Object)

    t = CreateObject("roStorageInfo","SD:")  

    result = {}
    result.result = t.GetFileSystemType()
    
    SendHttpResponse(e, result ,200)
End Sub

Sub GetStorageTotal(e as Object)

    t = CreateObject("roStorageInfo","SD:")  

    result = {}
    result.result = t.GetSizeInMegabytes()
    
    SendHttpResponse(e, result ,200)
End Sub

Sub SetTimezone(e as Object)

    tzId = e.GetRequestBodyString()
    t = CreateObject("roSystemTime")

    result = {}
    result.result =  t.SetTimeZone(tzId)
    result.tz = tzId
    
    SendHttpResponse(e, result, 200)
End Sub

Sub GetTimezone(e as Object)
    t = CreateObject("roSystemTime") 

    result = {}
    result.result = t.GetTimeZone()
    
    SendHttpResponse(e, result ,200)
End Sub

Sub TurnScreenOff(e as Object)

    mode = CreateObject("roVideoMode")

    result = {}
    result.result = mode.SetPowerSaveMode(true)
    SendHttpResponse(e, result, 200)
End Sub

Sub TurnScreenOn(e as Object)

    mode = CreateObject("roVideoMode")

    result = {}
    result.result = mode.SetPowerSaveMode(false)

    SendHttpResponse(e, result, 200)

End Sub

Sub SendHttpPOSTResponse(e as Object, statusCode as Integer)
	e.SendResponse(statusCode)
End Sub

Sub SendHttpResponse(e as Object, retAaOrStr, statusCode as Integer)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	If type(retAaOrStr) = "roAssociativeArray" Then
		ret$ = FormatJson(retAaOrStr)
	Else
		ret$ = retAaOrStr
	End If
	e.SetResponseBodyString(ret$)
	e.SendResponse(statusCode)
End Sub
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub GetNetworkInfo(e as Object)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	retAA = {}
	retAA.ethernet = {}
    retAA.wifi = {}
	m.mVar.GetNicInfo(0, retAA.ethernet)
    m.mVar.GetNicInfo(1, retAA.wifi)
	SendHttpResponse(e, retAA, 200)
End Sub
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Sub GetNicInfo(wiredOrWifi% as Integer, args as Object)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	nc = CreateObject("roNetworkConfiguration", wiredOrWifi%)
	cc = invalid
	If type(nc) = "roNetworkConfiguration" Then
		cc = nc.GetCurrentConfig()
	End If
	If cc <> invalid Then
        args.enabled = true
		args.priority = cc.metric
		args.hostname = cc.hostname
		args.ipAddress = cc.ip4_address
		args.subnetMask = cc.ip4_netmask
		args.defaultGateway = cc.ip4_gateway
		args.macAddress = cc.ethernet_mac
		args.domain = cc.domain
		args.dhcp = cc.dhcp
		args.dnsServers = cc.dns_servers
		args.timeServer = cc.time_server
        args.proxy = cc.configured_proxy
		If wiredOrWifi% = 1 Then
			args.ssid = cc.wifi_essid
		End If
	Else
        args.enabled = false
		args.priority = -1
		args.hostname = ""
		args.ipAddress = ""
		args.subnetMask = ""
		args.defaultGateway = ""
		args.macAddress = ""
		args.domain = ""
		args.dhcp = true
		args.dnsServers = ""
		args.timeServer = ""
        args.proxy = ""
		If wiredOrWifi% = 1 Then
			args.ssid = ""
		End If
	End If

	nc = invalid
End Sub

Function WebWindowHTML(index% as integer, url$ as string, RectX as integer, RectY as integer, RecWidth as integer, RecHeight as integer, Rotate as integer) as Object
	
	webRect=CreateObject("roRectangle", RectX, RectY, RecWidth, RecHeight)
    
    webPageConfig = {
        nodejs_enabled: false,
        brightsign_js_objects_enabled: false,
        javascript_enabled: true,
        mouse_enabled: true,
        scrollbar_enabled: false,
		port: m.msgPort,
        security_params: {
            websecurity: false,
            camera_enabled: true,
            insecure_https_enabled: false
        },
        hwz_default: "z-index:-1",
		url: url$,
        storage_path : "localStorage"
    }

    if Rotate = 90 then
        webPageConfig.AddReplace("transform","rot270")
        tempWidth = webRect.GetWidth()
        webRect.SetWidth(webRect.GetHeight())
        webRect.SetHeight(tempWidth)
        videoMode = CreateObject("roVideoMode")    
        widthToRemove = RectY + RecHeight
        webRect.SetX(videoMode.GetResX() - widthToRemove)
        webRect.SetY(RectX)
    else if Rotate = 270 then
        webPageConfig.AddReplace("transform","rot90")
        tempWidth = webRect.GetWidth()
        webRect.SetWidth(webRect.GetHeight())
        webRect.SetHeight(tempWidth)
        'videoMode = CreateObject("roVideoMode")    
        'widthToRemove = RectY + RecHeight
        webRect.SetX(RectY)
        webRect.SetY(RectX)
    end if
	
    webhtmlWidget = CreateObject("roHtmlWidget", webRect, webPageConfig)
    webhtmlWidget.Show()

	return webhtmlWidget
	
End Function

